//=============================================================================
// RPG Maker MZ - SKA Deluxe Content
// ----------------------------------------------------------------------------
// (C)2021 aura-dev
// This software is released under the MIT License.
// http://opensource.org/licenses/mit-license.php
// ----------------------------------------------------------------------------
// Version
// 1.0.0 2022/09/03
//=============================================================================

/*:
 * @target MZ
 * @plugindesc Availability management of deluxe content
 * @author aura-dev
 * @url https://gitgud.io/auragamedev/auramz
 *
 * @help deluxe.js
 *
 * Plugin for managing the availability of extra deluxe content
 *
 * @param deluxeConsole
 * @type boolean
 * @text Deluxe Console
 * @desc Whether the deluxe console is on or not
 * @default false
 * 
 * @param deluxeText_cte
 * @type text
 * @text Deluxe Text
 * @desc Will be appended to the game version if deluxe is active
 * @default -deluxe
 *
 */

window.AuraMZ = window.AuraMZ || {};
AuraMZ.Deluxe = {};

(($) => {
	const PLUGIN_ID = "deluxe";
	const PARAMS = PluginManager.parameters(PLUGIN_ID);

	Object.defineProperties($, {
		"deluxeText": { get: () => TextManager.message(`auramz/${PLUGIN_ID}-deluxeText_cte`) || PARAMS.deluxeText_cte }
	});

	$.deluxeConsole = PARAMS["deluxeConsole"] === 'true';

	if ($.deluxeConsole) {
		$._Scene_Title_start = Scene_Title.prototype.start;
		Scene_Title.prototype.start = function() {
			$._Scene_Title_start.call(this);
			if (AuraMZ.gameVersion) {
				AuraMZ.gameVersion = AuraMZ.gameVersion + $.deluxeText;
			}
		};
	}
})(AuraMZ.Deluxe);
